﻿using System;
using System.IO;
using System.Text;

class InsertLineNumbers
{
    /// <summary>
    /// Write a program that reads a text file and inserts 
    /// line numbers in front of each of its lines. 
    /// The result should be written to another text file.
    /// </summary>

    static void Main(string[] args)
    {
        // Getting Cyrillic encoding 
        System.Text.Encoding encoding = System.Text.Encoding.GetEncoding(1251);

        string inputFile = string.Empty;
        string inputFilePath = "../../Files/test.001.in.txt";
        string outputFilePath = "../../Files/test.001.out.txt";

        // We convert file to string and use method for adding line numbers
        inputFile = FileToString(inputFilePath);

        // Create a writer with the Cyrillic encoding
        StreamWriter streamWriter = new StreamWriter(
            outputFilePath, false, encoding);
        streamWriter.Write(inputFile);
        streamWriter.Close();
    }

    public static string FileToString(string filePath)
    {
        // Getting Cyrillic encoding 
        System.Text.Encoding encoding = System.Text.Encoding.GetEncoding(1251);

        StringBuilder stringBuilder = new StringBuilder();

        // Create a reader with the Cyrillic encoding
        using (StreamReader streamReader = new StreamReader(
            "../../Files/test.020.in.txt", encoding))
        {
            string line;
            int counter = 1;
            while ((line = streamReader.ReadLine()) != null)
            {
                stringBuilder.Append(counter);
                stringBuilder.Append(". ");
                stringBuilder.Append(line);
                if (!streamReader.EndOfStream)
                {
                    stringBuilder.Append(Environment.NewLine);
                }
                counter++;
            }
        }
        return stringBuilder.ToString();
    }
}