﻿using System;
using System.IO;

class AreaOfSubMatrixWithMaximalSum
{
    /// <summary>
    /// Write a program that reads a text file containing a square matrix of numbers 
    /// and finds in the matrix an area of size 2 x 2 with a maximal sum of its
    /// elements. The first line in the input file contains the size of
    /// matrix N. Each of the next N lines contain N numbers separated
    /// by space. The output should be a single number in a separate
    /// text file. Example:
    /// 4
    /// 2 3 3 4
    /// 0 2 3 4			output: 17
    /// 3 7 1 2
    /// 4 3 3 2
    /// </summary>

    static void Main(string[] args)
    {
        // Create reader
        StreamReader streamReader = new StreamReader(
            "../../Files/test.001.in.txt");

        // Create a square matrix of numbers
        int[,] squareMatrix;
            
        using (streamReader)
        {
            // The first line in the input file contains the size of matrix N 
            string firstLine = streamReader.ReadLine();
            int size = int.Parse(firstLine);

            // Each of the next N lines contain N numbers separated by space
            squareMatrix = new int[size, size];
            for (int i = 0; i < size; i++)
            {
                firstLine = streamReader.ReadLine();
                string[] elements = firstLine.Split(' ');
                for (int j = 0; j < size; j++)
                {
                    squareMatrix[i, j] = int.Parse(elements[j]);
                }
            }
        }

        // Find a 2 x 2 platform in a matrix with a maximal sum of its elements
        int bestSum = int.MinValue;
        for (int row = 0; row < squareMatrix.GetLength(0) - 1; row++)
        {
            for (int col = 0; col < squareMatrix.GetLength(1) - 1; col++)
            {
                int sum = squareMatrix[row, col] + squareMatrix[row, col + 1] +
                        squareMatrix[row + 1, col] + squareMatrix[row + 1, col + 1];

                if (bestSum < sum)
                {
                    bestSum = sum;
                }
            }
        }

        StreamWriter streamWriter = new StreamWriter(
            "../../Files/test.001.out.txt", false);
        using (streamWriter)
        {
            // Print the maximal sum of a 2 x 2 platform in a matrix
            Console.WriteLine(bestSum);
            streamWriter.WriteLine(bestSum);
        }
    }
}
