﻿using System;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

class ReplaceString
{
    /// <summary>
    ///  Task7
    /// Write a program that replaces all occurrences of the substring 
    /// "start" with the substring "finish" in a text file. 
    /// Ensure it will work with large files (e.g. 100 MB).
    /// Task8
    /// Modify the solution of the previous problem to replace 
    /// only whole words (not substrings).
    /// </summary>

    static void Main(string[] args)
    {
        // Getting Cyrillic encoding 
        System.Text.Encoding encoding = System.Text.Encoding.GetEncoding(1251);

        string filePath = "../../Files/test.001.in.txt";
        string fileContent = string.Empty;

        fileContent = FileToString(filePath);

        //Task7
        //uncomment row below to replace substrings
        fileContent = Regex.Replace(fileContent, "start", "finish");

        //Task8
        //uncomment row below to replace whole words
        //fileContent = Regex.Replace(fileContent, @"(\s|^)start(\s)", "$1finish$2");
        //fileContent = Regex.Replace(fileContent, @"\bstart\b", "finish");

        StreamWriter sw = new StreamWriter(
            "../../Files/test.020.out8.txt", false, encoding);
        sw.Write(fileContent);
        sw.Close();
    }

    public static string FileToString(string filePath)
    {
        // Getting Cyrillic encoding 
        System.Text.Encoding encoding = System.Text.Encoding.GetEncoding(1251);

        StringBuilder sb = new StringBuilder();
        StreamReader sr = new StreamReader("../../Files/test.001.in.txt", encoding);
        using (sr)
        {
            string line;
            while ((line = sr.ReadLine()) != null)
            {
                sb.Append(line);
                if (!sr.EndOfStream)
                {
                    sb.Append(Environment.NewLine);
                }
            }
        }
        return sb.ToString();
    }
}